package dev.shadowsoffire.apotheosis.adventure.affix.effect;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixInstance;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixType;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import java.util.Map;
import java.util.function.Function;
import net.minecraft.core.BlockPos;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.world.effect.MobEffectUtil;
import net.minecraft.world.effect.MobEffects;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraftforge.common.ForgeMod;
import net.minecraftforge.event.entity.player.PlayerEvent;
import net.minecraftforge.fluids.FluidType;

public class OmneticAffix extends Affix {
  public static final Codec<dev.shadowsoffire.apotheosis.adventure.affix.effect.OmneticAffix> CODEC;
  
  protected final Map<LootRarity, OmneticData> values;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)LootRarity.mapCodec(OmneticData.CODEC).fieldOf("values").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.affix.effect.OmneticAffix::new));
  }
  
  public OmneticAffix(Map<LootRarity, OmneticData> values) {
    super(AffixType.ABILITY);
    this.values = values;
  }
  
  public boolean canApplyTo(ItemStack stack, LootCategory cat, LootRarity rarity) {
    return (cat.isBreaker() && this.values.containsKey(rarity));
  }
  
  public MutableComponent getDescription(ItemStack stack, LootRarity rarity, float level) {
    return Component.m_237110_("affix." + getId() + ".desc", new Object[] { Component.m_237115_("misc.apotheosis." + ((OmneticData)this.values.get(rarity)).name) });
  }
  
  public void harvest(PlayerEvent.HarvestCheck e) {
    ItemStack stack = e.getEntity().m_21205_();
    if (!stack.m_41619_()) {
      AffixInstance inst = (AffixInstance)AffixHelper.getAffixes(stack).get(Apoth.Affixes.OMNETIC);
      if (inst != null && inst.isValid()) {
        OmneticData data = this.values.get(inst.rarity().get());
        for (ItemStack item : data.items()) {
          if (item.m_41735_(e.getTargetBlock())) {
            e.setCanHarvest(true);
            return;
          } 
        } 
      } 
    } 
  }
  
  public void speed(PlayerEvent.BreakSpeed e) {
    ItemStack stack = e.getEntity().m_21205_();
    if (!stack.m_41619_()) {
      AffixInstance inst = (AffixInstance)AffixHelper.getAffixes(stack).get(Apoth.Affixes.OMNETIC);
      if (inst != null && inst.isValid()) {
        float speed = e.getOriginalSpeed();
        OmneticData data = this.values.get(inst.rarity().get());
        for (ItemStack item : data.items())
          speed = Math.max(getBaseSpeed(e.getEntity(), item, e.getState(), e.getPosition().orElse(BlockPos.f_121853_)), speed); 
        e.setNewSpeed(speed);
      } 
    } 
  }
  
  public Codec<? extends Affix> getCodec() {
    return (Codec)CODEC;
  }
  
  static float getBaseSpeed(Player player, ItemStack tool, BlockState state, BlockPos pos) {
    float f = tool.m_41691_(state);
    if (f > 1.0F) {
      int i = EnchantmentHelper.m_44926_((LivingEntity)player);
      ItemStack itemstack = player.m_21205_();
      if (i > 0 && !itemstack.m_41619_())
        f += (i * i + 1); 
    } 
    if (MobEffectUtil.m_19584_((LivingEntity)player))
      f *= 1.0F + (MobEffectUtil.m_19586_((LivingEntity)player) + 1) * 0.2F; 
    if (player.m_21023_(MobEffects.f_19599_)) {
      switch (player.m_21124_(MobEffects.f_19599_).m_19564_()) {
        case 0:
        
        case 1:
        
        case 2:
        
        case 3:
        
        default:
          break;
      } 
      float f1 = 8.1E-4F;
      f *= f1;
    } 
    if (player.isEyeInFluidType((FluidType)ForgeMod.WATER_TYPE.get()) && !EnchantmentHelper.m_44934_((LivingEntity)player))
      f /= 5.0F; 
    if (!player.m_20096_())
      f /= 5.0F; 
    return f;
  }
}
